## ros-lunar-gscam 1.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(gscam)

# System Dependencies
find_package(PkgConfig)

pkg_check_modules(GSTREAMER QUIET gstreamer-0.10)
if(NOT GSTREAMER_FOUND)
  set(GSTREAMER_VERSION_1_x TRUE)
endif()
if(GSTREAMER_VERSION_1_x)
  message(STATUS "gst 1.0")
  pkg_check_modules(GSTREAMER REQUIRED gstreamer-1.0)
  pkg_check_modules(GST_APP REQUIRED gstreamer-app-1.0)
else()
  message(STATUS "gst 0.1")
  pkg_check_modules(GSTREAMER REQUIRED gstreamer-0.10)
  pkg_check_modules(GST_APP REQUIRED gstreamer-app-0.10)
endif()

if(USE_ROSBUILD)
  # Use rosbuild
  include($ENV{ROS_ROOT}/core/rosbuild/rosbuild.cmake)

  rosbuild_init()

  set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)
  set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)

  include_directories(${GLIB_INCLUDE_DIRS} ${GST_APP_INCLUDE_DIRS})

  rosbuild_add_library(gscam src/gscam.cpp)
  target_link_libraries(gscam
    ${GSTREAMER_LIBRARIES}
    ${GST_APP_LIBRARIES})

  rosbuild_add_executable(gscam_node src/gscam_node.cpp)
  target_link_libraries(gscam_node gscam
    ${GSTREAMER_LIBRARIES}
    ${GST_APP_LIBRARIES})
  set_target_properties(gscam_node PROPERTIES OUTPUT_NAME gscam)

  rosbuild_add_library(GSCamNodelet src/gscam_nodelet.cpp)
  target_link_libraries(GSCamNodelet gscam
    ${GSTREAMER_LIBRARIES}
    ${GST_APP_LIBRARIES})

else()
  # Use Catkin
  find_package(catkin REQUIRED 
    COMPONENTS roscpp image_transport sensor_msgs nodelet
    camera_calibration_parsers camera_info_manager
    )

  catkin_package(
    INCLUDE_DIRS include
    LIBRARIES gscam
    CATKIN_DEPENDS roscpp nodelet image_transport sensor_msgs
    camera_calibration_parsers camera_info_manager
    DEPENDS GSTREAMER GST_APP
    )

  include_directories(
    include
    ${catkin_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
    ${GST_APP_INCLUDE_DIRS})

  add_library(gscam src/gscam.cpp)
  target_link_libraries(gscam
    ${catkin_LIBRARIES}
    ${GSTREAMER_LIBRARIES}
    ${GST_APP_LIBRARIES})

  add_executable(gscam_node src/gscam_node.cpp)
  target_link_libraries(gscam_node gscam
    ${catkin_LIBRARIES}
    ${GSTREAMER_LIBRARIES}
    ${GST_APP_LIBRARIES})
  set_target_properties(gscam_node PROPERTIES OUTPUT_NAME gscam)

  add_library(GSCamNodelet src/gscam_nodelet.cpp)
  target_link_libraries(GSCamNodelet gscam
    ${catkin_LIBRARIES}
    ${GSTREAMER_LIBRARIES}
    ${GST_APP_LIBRARIES})

  # Install directives

  install(TARGETS gscam gscam_node GSCamNodelet
    ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
    RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
    )

  install(DIRECTORY include/${PROJECT_NAME}/
    DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
    PATTERN ".svn" EXCLUDE)

  install(FILES nodelet_plugins.xml
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
    )

  install(FILES
    examples/v4l.launch
    examples/gscam_nodelet.launch
    examples/nodelet_pipeline.launch
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
    )

  install(FILES examples/uncalibrated_parameters.ini
    DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/examples
    )

  # Interim compatibility
  # Remove this in the next release
  install(FILES ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/gscam_node
    DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})
  set(EXECUTABLE_OUTPUT_PATH ${CATKIN_DEVEL_PREFIX}/lib/${PROJECT_NAME})
endif()

# Interim compatibility
# Remove this in the next distribution release
configure_file(scripts/gscam_node.in ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/gscam_node)
file(COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/gscam_node 
  DESTINATION ${EXECUTABLE_OUTPUT_PATH}
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

=== debian/changelog ===
ros-lunar-gscam (1.0.0-0stretch) stretch; urgency=high

  * Gstreamer 1 0 support (#36 <https://github.com/ros-drivers/gscam/issues/36> )
    * delete unused manifest.xml, rosdep.yaml
    * use libgstreamer1.0 for lunar
    * Fixing preproc switches so that the 1.0 branch still builds against 0.1 without the switch flags
    * Preliminary GStreamer-1.0 support see README for more info
  * Contributors: Jonathan Bohren, Kei Okada

 -- Jonathan Bohren <jbo@jhu.edu>  Mon, 12 Jun 2017 15:00:00 -0000

ros-lunar-gscam (0.2.0-0stretch) stretch; urgency=high

  * add ROS Orphaned Package Maintainers to maintainer tag (#35 <https://github.com/ros-drivers/gscam/issues/35> )
  * gscam_nodelet.h: include scoped_ptr.hpp to compile with boost 1.57
    When compiling gscam with the currently latest boost version 1.57,
    it fails with:
    In file included from [...]/src/gscam_nodelet.cpp:5:0:
    [...]/include/gscam/gscam_nodelet.h:20:12: error: 'scoped_ptr' in namespace 'boost' does not name a template type
    boost::scoped_ptr<GSCam> gscam_driver_;
    ^
    [...]/include/gscam/gscam_nodelet.h:21:12: error: 'scoped_ptr' in namespace 'boost' does not name a template type
    boost::scoped_ptr<boost::thread> stream_thread_;
    ^
    It seems that the dependencies of boost/thread.hpp have changed
    and boost/scoped_ptr.hpp is not included anymore with
    boost/thread.hpp. Hence, the scoped_ptr is not defined in the
    gscam_nodelet header. After scanning quickly through the release
    notes of version 1.57, the boost bug tracker and a few changesets,
    I could not find not a hint what has changed in the thread library
    that gscam must include scoped_ptr itself.
    This commit simply addresses the compiler error by explicitly
    adding boost's scoped_ptr header in the gscam_nodelet header.
    As this commit also compiles with boost version 1.56, the commit
    is not expected to cause any problems with other build
    configurations.
    Signed-off-by: Lukas Bulwahn <lukas.bulwahn@oss.bmw-carit.de>
  * Remove dependency on opencv2 to fix under indigo
    Packages can no longer depend on opencv2 as of indigo.
    I've updated the package to depend instead on cv_bridge as suggested by http://wiki.ros.org/indigo/Migration#OpenCV.
  * Install the parameters file refered to in v4l.launch
  * Update package.xml
  * Examples: Added example for OSX (#15 <https://github.com/ros-drivers/gscam/issues/15>)
    Add a simple launch configuration for OSX. The camera can be selected by
    changing the default="0" to the appropriate integer.
  * Adding libraries to gscam target
    Fixes #13 <https://github.com/ros-drivers/gscam/issues/13>, now builds on stricter linkers
  * adding proper depends to catkin package call
  * Update minoru.launch
  * Contributors: CHILI Demo Corner, Jonathan Bohren, Kei Okada, Kenn Sebesta, Lukas Bulwahn, Russell Toris, Lukas Bulwahn

 -- Jonathan Bohren <jbo@jhu.edu>  Mon, 12 Jun 2017 15:00:00 -0000

ros-lunar-gscam (0.1.3-0stretch) stretch; urgency=high

  * Removed special characters from changelog.

 -- Jonathan Bohren <jbo@jhu.edu>  Wed, 18 Dec 2013 15:00:00 -0000

ros-lunar-gscam (0.1.2-0stretch) stretch; urgency=high

  * Added install targets for headers
  * Adding note on blackmagic decklink cards
  * Make sure nodelets are usable
  * Add jpeg direct publishing without decoding
  * Added system to use GST timestamps
  * Valid test file for jpeg-based publisher
  * Prepared for jpeg-only subscription
  * Install some launch files + added nodelet pipeline demo
  * Added missing bits to install the nodelet
  * Support for gray (mono8) cameras.
  * Remove unused ``bpp_`` member.
  * Expose default settings for ``image_encodings`` to the ros master.
  * Add in support for mono cameras.
  * Contributors: Cedric Pradalier, Holger Rapp, Jonathan Bohren, Russell Toris, Severin Lemaignan

 -- Jonathan Bohren <jbo@jhu.edu>  Wed, 18 Dec 2013 15:00:00 -0000

ros-lunar-gscam (0.1.1-0stretch) stretch; urgency=high

  * adding missing nodelet dep
  * Contributors: Jonathan Bohren

 -- Jonathan Bohren <jbo@jhu.edu>  Wed, 29 May 2013 15:00:00 -0000

ros-lunar-gscam (0.1.0-0stretch) stretch; urgency=high

  * adding maintainer/authors
  * making node name backwards compatible
  * re-adding package.xml
  * more info spam
  * removing old camera parameters file
  * updating gscam to use ``camera_info_manager``
  * Fixing nodelet, adding example
  * Making gscam a node and nodeelt
  * adding a note on the videofile player and wrapping readme
  * adding option to reopen a stream on EOF and adding a videofile example
  * Hybrid catkin-rosbuild buildsystem
  * adding minoru example
  * putting example nodes into namespaces, adding correct error check in gscam source, making tf frame publishing optional
  * rst->md
  * making gscam conform to standard ``camera_drivers`` ROS API, note, still need to add polled mode
  * fixes for decklink capture, adding another example
  * can't have manifest.xml and package.xml in same directory
  * removing unneeded find-pkgs
  * building in catkin ws
  * hybrid rosbuild/catkin buildsystem
  * Adding changes that were made to the distribution branch that
    should have gone into the exerpeimental branch in r2862.
    Added a bunch of enhancements and fixed bugs involving data
    missing fromthe image message headers.
    Index: src/gscam.cpp
    ===================================================================
    Added ``camera_name`` and ``camera_parameters_file`` globals for camera
    info.
    Moved ros init to the top of the main function.
    Gets the gstreamer configuration either from environment variable
    ``GSCAM_CONFIG`` or ROS param ``~/gscam_config``.
    Gets the camera calibration parameters from the file located at ROS
    param ``~/camera_parameters_file``, will look at
    "../camera_settings.txt" by default.
    A bunch of re-indenting for consistency.
    Updated a lot of error fprintfs to ``ROS_ERROR`` calls.


=== debian/control ===
Source: ros-lunar-gscam
Section: misc
Priority: extra
Maintainer: Jonathan Bohren <jbo@jhu.edu>
Build-Depends: debhelper (>= 9.0.0), libgstreamer-plugins-base1.0-dev, libgstreamer1.0-dev, ros-lunar-camera-calibration-parsers, ros-lunar-camera-info-manager, ros-lunar-catkin, ros-lunar-cv-bridge, ros-lunar-image-transport, ros-lunar-nodelet, ros-lunar-roscpp, ros-lunar-sensor-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-lunar-gscam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-lunar-camera-calibration-parsers, ros-lunar-camera-info-manager, ros-lunar-cv-bridge, ros-lunar-image-transport, ros-lunar-nodelet, ros-lunar-roscpp, ros-lunar-sensor-msgs
Description: A ROS camera driver that uses gstreamer to connect to devices such as webcams.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DH_OPTIONS=-v --buildsystem=cmake
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh  $@

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-gscam//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
